/*
 * intel.h
 *
 * intel-PARTI definitions, macros, and function prototypes...
 * Version 1.0
 *					shin 6/17/93 
 */

/* Intel iPSC header files */
#include <cube.h>

/*
 * Definitions
 */
/* tags for force type message */
#define FORCED_GATHER_EXECUTOR_MSG      1100000000
#define FORCED_SCATTER_EXECUTOR_MSG     1200000000
#define FORCED_ADD_EXECUTOR_MSG         1300000000
#define FORCED_SUB_EXECUTOR_MSG         1400000000
#define FORCED_MULT_EXECUTOR_MSG        1500000000

/* tags for unforce type message */
#define GATHER_EXECUTOR_MSG      	0100000000
#define SCATTER_EXECUTOR_MSG     	0200000000
#define ADD_EXECUTOR_MSG         	0300000000
#define SUB_EXECUTOR_MSG         	0400000000
#define MULT_EXECUTOR_MSG        	0500000000

/* tags for synchronizing message */
#define GATHER_SYNC                     0010000000
#define SCATTER_SYNC                    0020000000
#define ADD_SYNC                        0030000000
#define SUB_SYNC                        0040000000
#define MULT_SYNC                       0050000000

/* tags used in bisection routine */
#define  EXCHEVEN                       0100000000
#define  EXCHODD                        0150000000
#define  REVEVEN                        0200000000
#define  REVODD                         0250000000
#define  DISTEVEN                       0300000000 
#define  DISTODD                        0350000000


#define MAXNODES                        512
#define MAXCOUNT                        10000

#define TABLE_REMAP                     17018
#define MSG_TTABLE                      17097
#define MSG_PROC                        1550000000
#define MSG_OFFS                        1560000000

#define PARTI_ANY_NODE                  0

/* 
 * machine depedent functions
 */
#define PARTI_numprocs()	numnodes()
#define PARTI_myproc()		mynode()
#define PARTI_mypid()		mypid()
#define PARTI_infonode()	infonode()
#define PARTI_infocount()	infocount()
#define PARTI_infotype()	infotype()

#define PARTI_gsync()		gsync()
#define PARTI_bsend(tag,buf,len,node,pid) \
				csend(tag,buf,len,node,pid)
#define PARTI_csend(tag,buf,len,node,pid) \
				csend(tag,buf,len,node,pid)
#define PARTI_crecv(tag,buf,len,node,pid) \
				crecv(tag,buf,len)
#define PARTI_irecv(tag,buf,len,node,pid) \
				irecv(tag,buf,len)
#define PARTI_isend(tag,buf,len,node,pid) \
				isend(tag,buf,len,node,pid)
#define PARTI_msgwait(id)	msgwait(id)
#define PARTI_cprobe(id)	cprobe(id)
#define PARTI_iprobe(id)	iprobe(id)

#define PARTI_gisum(x,n,work)	gisum(x,n,work)
#define PARTI_gihigh(x,n,work)	gihigh(x,n,work)
#define PARTI_gilow(x,n,work)	gilow(x,n,work)
#define PARTI_gssum(x,n,work)   gssum(x,n,work)
#define PARTI_gshigh(x,n,work)  gshigh(x,n,work)
#define PARTI_gslow(x,n,work)   gslow(x,n,work)
#define PARTI_gdsum(x,n,work)   gdsum(x,n,work)
#define PARTI_gdhigh(x,n,work)  gdhigh(x,n,work)
#define PARTI_gdlow(x,n,work)   gdlow(x,n,work)
/* xlen must be equal for all processors (constraint due to CM5-CMMD port)*/
#define PARTI_gcol(x,xlen,y,ylen,work) \
				gcol(x,xlen,y,ylen,work)
